 CREATE OR REPLACE FUNCTION public.plan_create(pplanexternalid integer, pyear integer, pfacultyid integer)
 RETURNS integer
 LANGUAGE plpgsql
AS $function$ 
        DECLARE vID INT DEFAULT -1;
begin
--	select public.Plan_Create(
--	:pPlanExternalID,	-- put the pPlanExternalID parameter value instead of 'pPlanExternalID' (VARCHAR(9))
--	:pYear,	-- put the pYear parameter value instead of 'pYear' (INT)
--	:pFacultyID 	-- put the pFacultyID parameter value instead of 'pFacultyID' (INT)
--);
        INSERT INTO study_plans (ExternalID, Year, FacultyID) VALUES (pPlanExternalID, pYear, pFacultyID)
         on conflict on constraint study_plans_externalid_key
         do UPDATE set Year = pYear, FacultyID = pFacultyID
            returning id into vID;
        
        RETURN vID;
    END
 $function$


CREATE OR REPLACE FUNCTION public.subject_create(pfacultyid integer, psubjectname text, psubjectabbr character varying, pexternalid character varying)
 RETURNS integer
 LANGUAGE plpgsql
AS $function$ 
    DECLARE vSubjectID INT DEFAULT -1;
begin
--	select public.subject_create(
--	:pfacultyid,	-- put the pfacultyid parameter value instead of 'pfacultyid' (int4)
--	:psubjectname,	-- put the psubjectname parameter value instead of 'psubjectname' (text)
--	:psubjectabbr,	-- put the psubjectabbr parameter value instead of 'psubjectabbr' (varchar)
--	:pexternalid 	-- put the pexternalid parameter value instead of 'pexternalid' (varchar)
--);
    IF pSubjectName = '' THEN RETURN -1; END IF;
-- create/get subject (subject name is unique key)
    INSERT INTO subjects ("name", Abbr, ExternalID) VALUES (pSubjectName, pSubjectAbbr, pExternalID)
        ON conflict on constraint subjects_name_key
        do update set
          --  subjects.ID = LAST_INSERT_ID(subjects.ID),
            "name" = pSubjectName,
            Abbr = COALESCE(pSubjectAbbr, subjects.Abbr),
            ExternalID = COALESCE(pExternalID, subjects.ExternalID)
           returning id into vSubjectID; -- должно вернуть или новый ID или ID измененной записи
    BEGIN --handler block
      
        INSERT INTO subjects_faculties (SubjectID, FacultyID) VALUES (vSubjectID, pFacultyID)
            on conflict on constraint subjects_faculties_subjectid_facultyid_key --just stub
               do nothing; 
       EXCEPTION 
       when others then RETURN -1;        
    END;
    RETURN vSubjectID;
END
$function$;

CREATE OR REPLACE FUNCTION public.grade_getid(gradenum integer, pdegree bachelor_master_specialist)
 RETURNS TABLE("ID" integer)
 LANGUAGE plpgsql
AS $function$
begin
    return query
    SELECT  grades.ID as "ID"
        FROM grades
        WHERE grades.Num = gradeNum AND grades.Degree = pdegree;
end;
$function$;


CREATE OR REPLACE FUNCTION public."GetStudents"(pfacultyid integer, pgradeid integer, pgroupid integer, psemesterid integer, pword1 character varying, pword2 character varying, pword3 character varying)
 RETURNS TABLE("ID" integer, "LastName" character varying, "FirstName" character varying, "SecondName" character varying, "AccountID" integer, "GradeID" integer, "GradeNum" integer, "Degree" bachelor_master_specialist, "GroupID" integer, "GroupNum" integer)
 LANGUAGE plpgsql
AS $function$
  DECLARE FullName VARCHAR;
begin
	return query
  SELECT  view_students.StudentID AS "ID",
    view_students.LastName AS "LastName",
    view_students.FirstName AS "FirstName",
    view_students.SecondName AS "SecondName",
    view_students.AccountID AS "AccountID",
    view_students.GradeID AS "GradeID",
    view_students.GradeNum AS "GradeNum",
    view_students.Degree AS "Degree",
    view_students.GroupID AS "GroupID",
    view_students.GroupNum AS "GroupNum"
  FROM view_students
    WHERE
    CASE WHEN pSemesterID != 0 THEN view_students.SemesterID = pSemesterID ELSE
    TRUE
    END AND
      CASE WHEN pFacultyID != 0 THEN view_students.FacultyID = pFacultyID ELSE TRUE END AND
    CASE WHEN pGradeID != 0 THEN view_students.GradeID = pGradeID ELSE TRUE END AND
    CASE WHEN pGroupID != 0 THEN view_students.GroupID = pGroupID ELSE TRUE END AND
    CASE WHEN pWord1 != '' AND FullName != '' THEN
      CONCAT(view_students.LastName, ' ', view_students.FirstName, ' ', view_students.SecondName) LIKE CONCAT('%', pWord1, '%') AND 
      CONCAT(view_students.LastName, ' ', view_students.FirstName, ' ', view_students.SecondName) LIKE CONCAT('%', pWord2, '%') AND 
      CONCAT(view_students.LastName, ' ', view_students.FirstName, ' ', view_students.SecondName) LIKE CONCAT('%', pWord3, '%')
      ELSE TRUE END;
END
$function$

CREATE OR REPLACE FUNCTION public.getstudents(pfacultyid integer, pgradeid integer, pgroupid integer, psemesterid integer, pword1 character varying, pword2 character varying, pword3 character varying)
 RETURNS TABLE("ID" integer, "LastName" character varying, "FirstName" character varying, "SecondName" character varying, "AccountID" integer, "GradeID" integer, "GradeNum" integer, "Degree" bachelor_master_specialist, "GroupID" integer, "GroupNum" integer)
 LANGUAGE plpgsql
AS $function$
  DECLARE FullName VARCHAR;
begin
	return query
  SELECT  view_students.StudentID AS "ID",
    view_students.LastName AS "LastName",
    view_students.FirstName AS "FirstName",
    view_students.SecondName AS "SecondName",
    view_students.AccountID AS "AccountID",
    view_students.GradeID AS "GradeID",
    view_students.GradeNum AS "GradeNum",
    view_students.Degree AS "Degree",
    view_students.GroupID AS "GroupID",
    view_students.GroupNum AS "GroupNum"
  FROM view_students
    WHERE
    CASE WHEN pSemesterID != 0 THEN view_students.SemesterID = pSemesterID ELSE
    TRUE
    END AND
      CASE WHEN pFacultyID != 0 THEN view_students.FacultyID = pFacultyID ELSE TRUE END AND
    CASE WHEN pGradeID != 0 THEN view_students.GradeID = pGradeID ELSE TRUE END AND
    CASE WHEN pGroupID != 0 THEN view_students.GroupID = pGroupID ELSE TRUE END AND
    CASE WHEN pWord1 != '' AND FullName != '' THEN
	  -- нужно переделать через курсор 
      CONCAT(view_students.LastName, ' ', view_students.FirstName, ' ', view_students.SecondName) LIKE CONCAT('%', pWord1, '%') AND 
      CONCAT(view_students.LastName, ' ', view_students.FirstName, ' ', view_students.SecondName) LIKE CONCAT('%', pWord2, '%') AND 
      CONCAT(view_students.LastName, ' ', view_students.FirstName, ' ', view_students.SecondName) LIKE CONCAT('%', pWord3, '%')
      ELSE TRUE END;
END
$function$


CREATE OR REPLACE FUNCTION public.creategroup(pgradeid integer, pgroupnum integer, pspecname character varying, pfacultyid integer, pyear integer)
 RETURNS integer
 LANGUAGE plpgsql
AS $function$
 DECLARE vGroupID INT DEFAULT null; 
         vSpecId INT DEFAULT null; 
         vGroupYear INT DEFAULT null; 
         vIsSpecMatch BOOL DEFAULT null;
   
BEGIN
--select public.creategroup(
--	:pgradeid,	-- put the pgradeid parameter value instead of 'pgradeid' (int4)
--	:pgroupnum,	-- put the pgroupnum parameter value instead of 'pgroupnum' (int4)
--	:pspecname,	-- put the pspecname parameter value instead of 'pspecname' (varchar)
--	:pfacultyid,	-- put the pfacultyid parameter value instead of 'pfacultyid' (int4)
--	:pyear 	-- put the pyear parameter value instead of 'pyear' (int4)
--);    
-- create specialization vSpecId - UNIQUE (pSpecName,pFacultyID)
    select specializations.id into vSpecId
           from specializations
           where specializations.facultyid=pFacultyID and specializations."name" like pSpecName;
    if (vSpecId is null) then
         INSERT INTO specializations (Name, Abbr, FacultyID) 
         VALUES  (pSpecName, NULL, pFacultyID)
         returning id into vSpecId;
    end if;


-- create group  vGroupID - UNIQUE (pGradeID, pGroupNum, pFacultyID)
    select study_groups.id into vGroupID 
           from study_groups
           where study_groups.gradeid=pgradeID 
           		 and study_groups.groupnum= pGroupNum
           		 and study_groups.facultyid=pFacultyID;
    if ( vGroupID  is null) then
        INSERT INTO study_groups (GradeID, GroupNum, FacultyID) 
               VALUES (pGradeID, pGroupNum, pFacultyID)
               returning id into  vGroupID ;
    end if;
        

    SELECT groups_years.groupid, groups_years.specializationid = vSpecId
        INTO vGroupYear, vIsSpecMatch
        FROM groups_years
        WHERE groups_years.groupid = vGroupID AND groups_years."year" = pYear
        LIMIT 1;

        --RAISE notice 'vgroupyear = (%) visspecmatch= (%)', vGroupYear, vIsSpecMatch;
        
    IF  (vGroupYear is null) THEN
        INSERT INTO groups_years (GroupID, Year, SpecializationID)
        VALUES (vGroupID, pYear, vSpecId);
    ELSEIF NOT vIsSpecMatch THEN
        RETURN -1;
    END IF;

    RETURN vGroupID;
    EXCEPTION 
    	when others then 
   			RETURN -1;
END
$function$

CREATE OR REPLACE FUNCTION public.createaccount(pLastName character varying, pFirstName character varying, pSecondName character varying, pcode character varying, puserroleid integer)
 RETURNS integer
 LANGUAGE plpgsql
AS $function$
declare insID int;
begin
--	select public.createaccount(
--	:pcode,	-- put the pcode parameter value instead of 'pcode' (varchar)
--	:puserroleid 	-- put the puserroleid parameter value instead of 'puserroleid' (int4)
--);

    INSERT INTO accounts (Login , Password , EMail, UserRoleID, ActivationCode, FirstName, SecondName, LastName)
        VALUES  ( NULL, NULL, NULL, pUserRoleID, pCode, pFirstName, pSecondName, pLastName) returning ID into insID;
    RETURN insID;
END;
$function$

CREATE OR REPLACE FUNCTION public.recordbook_bind(pexternalid character varying, pstudentid integer, pplanid integer)
 RETURNS integer
 LANGUAGE plpgsql
AS $function$
        DECLARE vRecordBookID INT DEFAULT -1;
BEGIN
--select public.recordbook_bind(
--	:pexternalid,	-- put the pexternalid parameter value instead of 'pexternalid' (varchar)
--	:pstudentid,	-- put the pstudentid parameter value instead of 'pstudentid' (int4)
--	:pplanid 	-- put the pplanid parameter value instead of 'pplanid' (int4)
--);
        INSERT INTO record_books (StudentID, ExternalID)
            VALUES  (pStudentID, pExternalID)
           on conflict on constraint record_books_externalid_key do
           update set StudentID = pStudentID
                      -- record_books.ID = LAST_INSERT_ID(record_books.ID)
                     returning ID into vRecordBookID;

        INSERT INTO record_books_plans (RecordBookID, StudyPlanID)
            VALUES (vRecordBookID, pPlanID)
            on conflict on constraint recordbookid_studyplanid_record_books_plans_key do
            nothing;

        RETURN vRecordBookID;

       EXCEPTION
         when others then RETURN -1;
    END
 $function$


